B

B - Local Extrema

CodeForces - 888A

You are given an array a. Some element of this array ai is a local minimum iff it is strictly less than both of its neighbours (that is, ai < ai - 1 and ai < ai + 1). Also the element can be called local maximum iff it is strictly greater than its neighbours (that is, ai > ai - 1 and ai > ai + 1). Since a1 and an have only one neighbour each, they are neither local minima nor local maxima.

An element is called a local extremum iff it is either local maximum or local minimum. Your task is to calculate the number of local extrema in the given array.

Input

The first line contains one integer n (1 ≤ n ≤ 1000) — the number of elements in array a.

The second line contains n integers a1a2, ..., an (1 ≤ ai ≤ 1000) — the elements of array a.

Output

Print the number of local extrema in the given array.

Examples

Input
3
1 2 3
Output
0
Input
4
1 5 2 5
Output
2
签到题1
#include<bits/stdc++.h>
using namespace std;
const int N=1E4+;
int arr[N];
int main(){
int n;
cin>>n;
for(int i=;i<=n;i++) scanf("%d",&arr[i]);
int ans=;
for(int i=;i<=n-;i++){
if(arr[i]>arr[i-]&&arr[i]>arr[i+]||arr[i]<arr[i-]&&arr[i]<arr[i+]) ans++;
}
cout<<ans<<endl;
return ;
}

D - Buggy Robot

签到题2  由于机器人最终在起点,所以L=R,  U=D ,答案为2*min(L,R)+2*min(U,D)

#include<bits/stdc++.h>
using namespace std;
const int N=1E3+;
int L=,R=,U=,D=;
int main(){
int n;
cin>>n;
string x;
cin>>x;
for(int i=;i<n;i++){
if(x[i]=='L') L++;
else if(x[i]=='R') R++;
else if(x[i]=='U') U++;
else if(x[i]=='D') D++;
}
int ans1=min(L,R);
int ans2=min(U,D);
cout<<*ans1+*ans2<<endl;
return ;
}

E - K-Dominant Character

题解:记录字符的出现位置,对于相同的字符,间隔去最大值(不要忘了边界),不同字符去最小

#include<bits/stdc++.h>
using namespace std;
const int N=1E5+;
const int M=1e9+; char arr[N];
int brr[N];
vector<int >ve[N];
bool mark[N]; int main(){
memset(mark,,sizeof(mark));
scanf("%s",arr+);
int n=strlen(arr+);
int pos=;
for(int i=;i<=n;i++){
int y=arr[i];
if(!mark[y]) {
mark[y]=;
brr[pos++]=y;
}
ve[y].push_back(i);
}
int ans=M,k;
for(int i=;i<pos;i++){
int y=brr[i];
int x=ve[y].size();
if(x==){
k=max(ve[y][],n-ve[y][]+);
}
else {
for(int j=;j<x;j++){
if(j==) k=ve[y][j];
else {
k=max(k,ve[y][j]-ve[y][j-]);
}
}
k=max(k,n-ve[y][x-]+);
}
ans=min(ans,k);
}
cout<<ans<<endl;
return ;
}

G - Almost Identity Permutations

A permutation p of size n is an array such that every integer from 1 to n occurs exactly once in this array.

Let's call a permutation an almost identity permutation iff there exist at least n - k indices i (1 ≤ i ≤ n) such that pi = i.

Your task is to count the number of almost identity permutations for given numbers n and k.

Input

The first line contains two integers n and k (4 ≤ n ≤ 1000, 1 ≤ k ≤ 4).

Output

Print the number of almost identity permutations for given n and k.

Examples

Input
4 1
Output
1
Input
4 2
Output
7
Input
5 3
Output
31
Input
5 4
Output
76
当K==1 的时候,直接输出1,
当K=2的时候哦 答案为c(n,2);
当k=3的时候答案为c(n,3)*2;(这里的2是怎么来的?由于我们选了3个数,即这3个数不能再原位置,比如1,2,3这三个数,要是其下标不等于其值,只能是3 1 2或者2 3 1共两种)
当k==4的时候答案为c(n,4)*(9)(这里的9与上同理)
然后在累加,即 k=2的最终结果等于k=1+k=2
k=3的最终结果等于k=3 + k=2 + k=1
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
int main(){
ll n,k;
cin>>n>>k;
ll ans=;
for(int i=;i<=k;i++){
if(i==){
ans+=n*(n-)/;
}
else if(i==){
ans+=n*(n-)*(n-)/ *;
}
else if(i==){
ans+=n*(n-)*(n-)*(n-)/ *;
}
}
ans++;
cout<<ans<<endl;
return ;
}

H - Alyona and Spreadsheet

During the lesson small girl Alyona works with one famous spreadsheet computer program and learns how to edit tables.

Now she has a table filled with integers. The table consists of n rows and m columns. By ai, j we will denote the integer located at the i-th row and the j-th column. We say that the table is sorted in non-decreasing order in the column j if ai, j ≤ ai + 1, j for all i from 1 to n - 1.

Teacher gave Alyona k tasks. For each of the tasks two integers l and r are given and Alyona has to answer the following question: if one keeps the rows from l to r inclusive and deletes all others, will the table be sorted in non-decreasing order in at least one column? Formally, does there exist such j that ai, j ≤ ai + 1, j for all i from l to r - 1 inclusive.

Alyona is too small to deal with this task and asks you to help!

Input

The first line of the input contains two positive integers n and m (1 ≤ n·m ≤ 100 000) — the number of rows and the number of columns in the table respectively. Note that your are given a constraint that bound the product of these two integers, i.e. the number of elements in the table.

Each of the following n lines contains m integers. The j-th integers in the i of these lines stands for ai, j (1 ≤ ai, j ≤ 109).

The next line of the input contains an integer k (1 ≤ k ≤ 100 000) — the number of task that teacher gave to Alyona.

The i-th of the next k lines contains two integers li and ri (1 ≤ li ≤ ri ≤ n).

Output

Print "Yes" to the i-th line of the output if the table consisting of rows from li to ri inclusive is sorted in non-decreasing order in at least one column. Otherwise, print "No".

Example

Input
5 4
1 2 3 5
3 1 3 2
4 5 2 3
5 5 3 2
4 4 3 4
6
1 1
2 5
4 5
3 5
1 3
1 5
Output
Yes
No
Yes
Yes
Yes
No

Note

In the sample, the whole table is not sorted in any column. However, rows 1–3 are sorted in column 1, while rows 4–5 are sorted in column 3.

题解:我们开一个数组d,用来记录存在某一列使得第从l行到 r 行,该列元素非递减排序,比如说d[a]=b即从b行到a行存在某列为非递减列,这里的b一定是满足条件里最小的那一个

#include<bits/stdc++.h>
using namespace std;
const int N=1e5+;
const int INF=1e9+;
int d[N],maxx[N],ans[N];
int main(){
int n,m;
cin>>n>>m;
int a; for(int i=;i<=n;i++){
int minn=INF;
for(int j=;j<=m;j++){
scanf("%d",&a);
if(i==) {
maxx[j]=a;
d[j]=i;
}
else {
if(a<maxx[j]) d[j]=i;
maxx[j]=a;
}
minn=min(minn,d[j]);
}
ans[i]=minn;
} int k;
cin>>k;
while(k--){
int l,r;
scanf("%d%d",&l,&r);
if(l>=ans[r]) puts("Yes");
else puts("No");
}
return ;
}

I - Shell Game

Bomboslav likes to look out of the window in his room and watch lads outside playing famous shell game. The game is played by two persons: operator and player. Operator takes three similar opaque shells and places a ball beneath one of them. Then he shuffles the shells by swapping some pairs and the player has to guess the current position of the ball.

Bomboslav noticed that guys are not very inventive, so the operator always swaps the left shell with the middle one during odd moves (first, third, fifth, etc.) and always swaps the middle shell with the right one during even moves (second, fourth, etc.).

Let's number shells from 0 to 2 from left to right. Thus the left shell is assigned number 0, the middle shell is 1 and the right shell is 2. Bomboslav has missed the moment when the ball was placed beneath the shell, but he knows that exactly n movements were made by the operator and the ball was under shell x at the end. Now he wonders, what was the initial position of the ball?

Input

The first line of the input contains an integer n (1 ≤ n ≤ 2·109) — the number of movements made by the operator.

The second line contains a single integer x (0 ≤ x ≤ 2) — the index of the shell where the ball was found after n movements.

Output

Print one integer from 0 to 2 — the index of the shell where the ball was initially placed.

Examples

Input
4
2
Output
1
Input
1
1
Output
0

Note

In the first sample, the ball was initially placed beneath the middle shell and the operator completed four movements.

  1. During the first move operator swapped the left shell and the middle shell. The ball is now under the left shell.
  2. During the second move operator swapped the middle shell and the right one. The ball is still under the left shell.
  3. During the third move operator swapped the left shell and the middle shell again. The ball is again in the middle.
  4. Finally, the operators swapped the middle shell and the right shell. The ball is now beneath the right shell

找规律,,6组一循环

#include<bits/stdc++.h>
using namespace std; int main(){
int n;
cin>>n;
int x;
cin>>x;
n=n%;
if(n==){
if(x==) cout<<<<endl;
else if(x==) cout<<<<endl;
else if(x==) cout<<<<endl;
}
else if(n==){
if(x==) cout<<<<endl;
else if(x==) cout<<<<endl;
else if(x==) cout<<<<endl;
}
else if(n==){
if(x==) cout<<<<endl;
else if(x==) cout<<<<endl;
else if(x==) cout<<<<endl; }
else if(n==){
if(x==) cout<<<<endl;
if(x==) cout<<<<endl;
if(x==) cout<<<<endl;
}
else if(n==){
if(x==) cout<<<<endl;
if(x==) cout<<<<endl;
if(x==) cout<<<<endl;
}
else if(n==){
cout<<x<<endl;
}
return ;
}

K - Cloud of Hashtags

Vasya is an administrator of a public page of organization "Mouse and keyboard" and his everyday duty is to publish news from the world of competitive programming. For each news he also creates a list of hashtags to make searching for a particular topic more comfortable. For the purpose of this problem we define hashtag as a string consisting of lowercase English letters and exactly one symbol '#' located at the beginning of the string. The length of the hashtag is defined as the number of symbols in it without the symbol '#'.

The head administrator of the page told Vasya that hashtags should go in lexicographical order (take a look at the notes section for the definition).

Vasya is lazy so he doesn't want to actually change the order of hashtags in already published news. Instead, he decided to delete some suffixes (consecutive characters at the end of the string) of some of the hashtags. He is allowed to delete any number of characters, even the whole string except for the symbol '#'. Vasya wants to pick such a way to delete suffixes that the total number of deleted symbols is minimum possible. If there are several optimal solutions, he is fine with any of them.

Input

The first line of the input contains a single integer n (1 ≤ n ≤ 500 000) — the number of hashtags being edited now.

Each of the next n lines contains exactly one hashtag of positive length.

It is guaranteed that the total length of all hashtags (i.e. the total length of the string except for characters '#') won't exceed 500 000.

Output

Print the resulting hashtags in any of the optimal solutions.

Examples

Input
3
#book
#bigtown
#big
Output
#b
#big
#big
Input
3
#book
#cool
#cold
Output
#book
#co
#cold
Input
4
#car
#cart
#art
#at
Output
#
#
#art
#at
Input
3
#apple
#apple
#fruit
Output
#apple
#apple
#fruit

Note

Word a1, a2, ..., am of length m is lexicographically not greater than word b1, b2, ..., bk of length k, if one of two conditions hold:

  • at first position i, such that ai ≠ bi, the character ai goes earlier in the alphabet than character bi, i.e. a has smaller character than b in the first position where they differ;
  • if there is no such position i and m ≤ k, i.e. the first word is a prefix of the second or two words are equal.

The sequence of words is said to be sorted in lexicographical order if each word (except the last one) is lexicographically not greater than the next word.

For the words consisting of lowercase English letters the lexicographical order coincides with the alphabet word order in the dictionary.

According to the above definition, if a hashtag consisting of one character '#' it is lexicographically not greater than any other valid hashtag. That's why in the third sample we can't keep first two hashtags unchanged and shorten the other two.

到着来,用一个string  记录上一个字符串,然后比较,如果比y小的话,直接入栈,否则就 拆分后入栈

#include<bits/stdc++.h>
using namespace std; vector<string >ve;
stack<string >st; int main(){ int n;
cin>>n; for(int i=;i<=n;i++){
string x;
cin>>x;
ve.push_back(x);
}
string y; for(int i=n-;i>=;i--){
if(i==n-) {
st.push(ve[i]);
y=ve[i];
}
else { if(ve[i]<=y){
st.push(ve[i]);
y=ve[i];
} else{
string xx=ve[i];
string xxx="";
int ll=y.size(); for(int j=;j<ll;j++){
if(xx[j]>y[j]) {
break;
}
else {
xxx+=xx[j];
}
}
st.push(xxx);
y=xxx;
}
}
} while(st.size()){
cout<<st.top()<<endl;
st.pop();
}
return ;
}

L - Game of Credit Cards

After the fourth season Sherlock and Moriary have realized the whole foolishness of the battle between them and decided to continue their competitions in peaceful game of Credit Cards.

Rules of this game are simple: each player bring his favourite n-digit credit card. Then both players name the digits written on their cards one by one. If two digits are not equal, then the player, whose digit is smaller gets a flick (knock in the forehead usually made with a forefinger) from the other player. For example, if n = 3, Sherlock's card is 123 and Moriarty's card has number 321, first Sherlock names 1 and Moriarty names 3 so Sherlock gets a flick. Then they both digit 2 so no one gets a flick. Finally, Sherlock names 3, while Moriarty names 1 and gets a flick.

Of course, Sherlock will play honestly naming digits one by one in the order they are given, while Moriary, as a true villain, plans to cheat. He is going to name his digits in some other order (however, he is not going to change the overall number of occurences of each digit). For example, in case above Moriarty could name 1, 2, 3 and get no flicks at all, or he can name 2, 3 and 1 to give Sherlock two flicks.

Your goal is to find out the minimum possible number of flicks Moriarty will get (no one likes flicks) and the maximum possible number of flicks Sherlock can get from Moriarty. Note, that these two goals are different and the optimal result may be obtained by using different strategies.

Input

The first line of the input contains a single integer n (1 ≤ n ≤ 1000) — the number of digits in the cards Sherlock and Moriarty are going to use.

The second line contains n digits — Sherlock's credit card number.

The third line contains n digits — Moriarty's credit card number.

Output

First print the minimum possible number of flicks Moriarty will get. Then print the maximum possible number of flicks that Sherlock can get from Moriarty.

Examples

Input
3
123
321
Output
0
2
Input
2
88
00
Output
2
0

Note

First sample is elaborated in the problem statement. In the second sample, there is no way Moriarty can avoid getting two flicks.

//谁小谁获获得得轻弹
#include<bits/stdc++.h>
using namespace std;
int main(){
int n;
cin>>n;
string s,m;
cin>>s;
cin>>m;
sort(s.begin(),s.end());
sort(m.begin(),m.end());
int pos=;
int a1=,ans1=n;
for(int i=;i<n;i++){
for(int j=pos;j<n;j++){
if(s[i]<=m[j]){
pos=j+;
a1++;
break;
}
}
}
ans1-=a1;
int a2=,ans2=n;
pos=;
for(int i=;i<n;i++){
for(int j=pos;j<n;j++){
if(s[i]<m[j]){
pos=j+;
a2++;
break;
}
}
}
cout<<ans1<<endl;
cout<<a2<<endl;
return ;
}

First Training的更多相关文章

  1. hdu 4946 2014 Multi-University Training Contest 8

    Area of Mushroom Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) ...

  2. 2016 Multi-University Training Contests

    2016 Multi-University Training Contest 1 2016 Multi-University Training Contest 2 2016 Multi-Univers ...

  3. 2016 Multi-University Training Contest 2 D. Differencia

    Differencia Time Limit: 10000/10000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Tot ...

  4. 2016 Multi-University Training Contest 1 G. Rigid Frameworks

    Rigid Frameworks Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) ...

  5. ACM: Gym 101047K Training with Phuket's larvae - 思维题

     Gym 101047K Training with Phuket's larvae Time Limit:2000MS     Memory Limit:65536KB     64bit IO F ...

  6. The Solution of UESTC 2016 Summer Training #1 Div.2 Problem C

    Link http://acm.hust.edu.cn/vjudge/contest/121539#problem/C Description standard input/output After ...

  7. 2012 Multi-University Training Contest 9 / hdu4389

    2012 Multi-University Training Contest 9 / hdu4389 打巨表,实为数位dp 还不太懂 先这样放着.. 对于打表,当然我们不能直接打,这里有技巧.我们可以 ...

  8. 2014 Multi-University Training Contest 9#11

    2014 Multi-University Training Contest 9#11 Killing MonstersTime Limit: 2000/1000 MS (Java/Others)   ...

  9. 2014 Multi-University Training Contest 9#6

    2014 Multi-University Training Contest 9#6 Fast Matrix CalculationTime Limit: 2000/1000 MS (Java/Oth ...

  10. 2016 Multi-University Training Contest 1

    8/11 2016 Multi-University Training Contest 1 官方题解 老年选手历险记 最小生成树+线性期望 A Abandoned country(BH) 题意: 1. ...

随机推荐

  1. CF1327D Infinite Path 题解

    原题链接 太坑了我谔谔 简要题意: 求一个排列的多少次幂能达到另一个排列.排列的幂定义见题.(其实不是新定义的,本来就是这么乘的) 很显然,这不像快速幂那样可以结合律. 既然这样,就从图入手. 将 \ ...

  2. 题解 SP2916 【GSS5 - Can you answer these queries V】

    前言 最近沉迷于数据结构,感觉数据结构很有意思. 正文 分析 先来分类讨论一下 1. \(x2<y1\) 如果 \(y1<x2\) 的话,答案 \(=\max \limits_{ y1 \ ...

  3. 图-连通分量-DFS-并查集-695. 岛屿的最大面积

    2020-03-15 16:41:45 问题描述: 给定一个包含了一些 0 和 1的非空二维数组 grid , 一个 岛屿 是由四个方向 (水平或垂直) 的 1 (代表土地) 构成的组合.你可以假设二 ...

  4. C 实战练习题目1

    题目:有1.2.3.4个数字,能组成多少个互不相同且无重复数字的三位数?都是多少? 程序分析:可填在百位.十位.个位的数字都是1.2.3.4.组成所有的排列后再去 掉不满足条件的排列. 实例: #in ...

  5. Android | 教你如何用华为HMS MLKit SDK 三十分钟在安卓上开发一个微笑抓拍神器

    Android | 只要三十分钟就可以在手机上开发一个微笑抓拍神器!!! 前言 前段时间Richard Yu在发布会上给大家介绍了华为HMS Core4.0,回顾发布会信息请戳: 华为面向全球发布HM ...

  6. PyCharm3.0 快捷键

    1.编辑(Editing) Ctrl + Space    基本的代码完成(类.方法.属性)Ctrl + Alt + Space  快速导入任意类Ctrl + Shift + Enter    语句完 ...

  7. MySql查询当天、本周、本月、本季度、本年的数据

    1.今天 SELECT * FROM 表名 WHERE TO_DAYS(时间字段名) = TO_DAYS(NOW()); 2.昨天 ; 3.本周 SELECT * FROM 表名 WHERE YEAR ...

  8. 深入理解Java虚拟机(第三版)-13.Java内存模型与线程

    13.Java内存模型与线程 1.Java内存模型 Java 内存模型的主要目的是定义程序中各种变量的访问规则,即关注在虚拟机中把变量值存储到主内存和从内存中取出变量值的底层细节 该变量指的是 实例字 ...

  9. Java实现3次找到假球

    前言 之前老师让写一个程序,就写了写. 正文 题目要求 程序要求 10个铅球中有一个假球(比其他铅球的重量要轻),用天平三次称出假球. 程序设计思路 第一次使用天平分别称5个球,判断轻的一边有假球:拿 ...

  10. bootstrip安装

    什么是Bootstrap Bootstrap,来自 Twitter,是目前最受欢迎的前端框架.Bootstrap 是基于 HTML.CSS.JAVASCRIPT 的,它简洁灵活,使得 Web 开发更加 ...